'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _redux = require('redux');

var _reduxThunk = require('redux-thunk');

var _reduxThunk2 = _interopRequireDefault(_reduxThunk);

var _reducers = require('../reducers');

var _connectWithInputs = require('../util/connectWithInputs');

var _connectWithInputs2 = _interopRequireDefault(_connectWithInputs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Creates a local store for redux-inputs unique to this component and its children
 * The caveat here is that if the component unmounts, the store is destroyed, just like component state
 */
var LocalInputs = function (_React$Component) {
    (0, _inherits3.default)(LocalInputs, _React$Component);

    function LocalInputs(props) {
        (0, _classCallCheck3.default)(this, LocalInputs);

        var _this = (0, _possibleConstructorReturn3.default)(this, (LocalInputs.__proto__ || (0, _getPrototypeOf2.default)(LocalInputs)).call(this, props));

        var inputsConfig = props.inputsConfig;

        _this._store = (0, _redux.createStore)((0, _redux.combineReducers)({
            inputs: (0, _reducers.createInputsReducer)(inputsConfig)
        }), (0, _redux.applyMiddleware)(_reduxThunk2.default));
        _this._ConnectedInputs = (0, _connectWithInputs2.default)(inputsConfig)()(function (_ref) {
            var reduxInputs = _ref.reduxInputs,
                children = _ref.children;
            return children(reduxInputs);
        });
        return _this;
    }

    (0, _createClass3.default)(LocalInputs, [{
        key: 'render',
        value: function render() {
            var children = this.props.children;

            var ConnectedInputs = this._ConnectedInputs;
            // Connects children component in propsMode so we don't have to set up a `Provider`
            return _react2.default.createElement(ConnectedInputs, { store: this._store, children: children });
        }
    }]);
    return LocalInputs;
}(_react2.default.Component);

exports.default = LocalInputs;


LocalInputs.propTypes = {
    inputsConfig: _propTypes2.default.object.isRequired,
    children: _propTypes2.default.func.isRequired // Callback with reduxInputs props
};