'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _mapValues2 = require('lodash/mapValues');

var _mapValues3 = _interopRequireDefault(_mapValues2);

var _omit2 = require('lodash/omit');

var _omit3 = _interopRequireDefault(_omit2);

var _mountPoint = require('./mountPoint');

var _actions = require('../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Helper function for providing props to redux-input controlled components
 * @param inputConfig
 * @param state - redux-inputs form state
 * @param dispatcher
 */
exports.default = function (inputConfig, inputsState, dispatch) {
    return (0, _mapValues3.default)((0, _omit3.default)(inputConfig, _mountPoint.REDUX_MOUNT_POINT), function (config, id) {
        var inputState = inputsState[id];
        (0, _invariant2.default)(inputState, '[redux-inputs]: ' + id + ' not found in state. Make sure to configure your redux-input reducer.');

        var value = inputState.value,
            error = inputState.error,
            otherState = (0, _objectWithoutProperties3.default)(inputState, ['value', 'error']);

        var hasError = typeof error !== 'undefined';

        return (0, _extends3.default)({
            _id: [(0, _mountPoint.getReduxMountPoint)(inputConfig), id].join('-'),
            value: hasError ? error : value,
            error: hasError,

            // Prebound change callback
            dispatchChange: function dispatchChange(newVal) {
                return dispatch((0, _actions.updateAndValidate)(inputConfig, (0, _defineProperty3.default)({}, id, newVal)));
            }

        }, config.props, otherState);
    });
};