'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getInputsFromState = getInputsFromState;
exports.inputsWithErrors = inputsWithErrors;

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _property2 = require('lodash/property');

var _property3 = _interopRequireDefault(_property2);

var _reduce2 = require('lodash/reduce');

var _reduce3 = _interopRequireDefault(_reduce2);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _includes2 = require('lodash/includes');

var _includes3 = _interopRequireDefault(_includes2);

var _mountPoint = require('./mountPoint');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getInputsFromState() {
    var inputConfigOrMountPoint = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _mountPoint.DEFAULT_REDUX_MOUNT_POINT;
    var state = arguments[1];
    var inputKeys = arguments[2];

    var mountPoint = typeof inputConfigOrMountPoint === 'string' ? inputConfigOrMountPoint : (0, _mountPoint.getReduxMountPoint)(inputConfigOrMountPoint);

    var inputsState = (0, _property3.default)(mountPoint)(state);
    (0, _invariant2.default)(inputsState, '[redux-inputs]: no state found at \'' + mountPoint + '\', check your reducers to make sure it exists or change reduxMountPoint in your inputConfig.');

    if (inputKeys) {
        return (0, _reduce3.default)(inputsState, function (result, input, key) {
            if ((0, _includes3.default)(inputKeys, key)) {
                result[key] = input;
            }
            return result;
        }, {});
    } else {
        return inputsState;
    }
}

function inputsWithErrors(inputs) {
    var erroredInputs = (0, _reduce3.default)(inputs, function (result, input, key) {
        if (typeof input.error !== 'undefined') {
            result[key] = input;
        }
        return result;
    }, {});

    return (0, _isEmpty3.default)(erroredInputs) ? false : erroredInputs;
}