'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.formSelector = exports.validSelector = exports.pristineSelector = exports.validatingSelector = exports.valuesSelector = exports.inputsSelector = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _reduce2 = require('lodash/reduce');

var _reduce3 = _interopRequireDefault(_reduce2);

var _some2 = require('lodash/some');

var _some3 = _interopRequireDefault(_some2);

var _reselect = require('reselect');

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getValuesFromInputs = function getValuesFromInputs(inputs) {
    return (0, _reduce3.default)(inputs, function (acc, input, key) {
        return (0, _extends4.default)({}, acc, (0, _defineProperty3.default)({}, key, input.value));
    }, {});
};
var areInputsValidating = function areInputsValidating(inputs) {
    return (0, _some3.default)(inputs, function (input) {
        return input.validating;
    });
};
var areInputsPristine = function areInputsPristine(inputs) {
    return !(0, _some3.default)(inputs, function (input) {
        return !input.pristine;
    });
};
var areInputsValid = function areInputsValid(inputs) {
    return !(0, _helpers.inputsWithErrors)(inputs);
};

var inputsSelector = exports.inputsSelector = function inputsSelector(inputConfig, inputKeys) {
    return function (state) {
        return (0, _helpers.getInputsFromState)(inputConfig, state, inputKeys);
    };
};

var valuesSelector = exports.valuesSelector = function valuesSelector(inputConfig, inputKeys) {
    return (0, _reselect.createSelector)(inputsSelector(inputConfig, inputKeys), getValuesFromInputs);
};

var validatingSelector = exports.validatingSelector = function validatingSelector(inputConfig, inputKeys) {
    return (0, _reselect.createSelector)(inputsSelector(inputConfig, inputKeys), areInputsValidating);
};

var pristineSelector = exports.pristineSelector = function pristineSelector(inputConfig, inputKeys) {
    return (0, _reselect.createSelector)(inputsSelector(inputConfig, inputKeys), areInputsPristine);
};

var validSelector = exports.validSelector = function validSelector(inputConfig, inputKeys) {
    return (0, _reselect.createSelector)(inputsSelector(inputConfig, inputKeys), areInputsValid);
};

var formSelector = exports.formSelector = function formSelector(inputConfig, inputKeys) {
    return (0, _reselect.createSelector)(valuesSelector(inputConfig, inputKeys), validatingSelector(inputConfig, inputKeys), pristineSelector(inputConfig, inputKeys), validSelector(inputConfig, inputKeys), function (values, validating, pristine, valid) {
        return {
            values: values,
            validating: validating,
            pristine: pristine,
            valid: valid
        };
    });
};